﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static СУБД_Фабрика.FormManager;

namespace СУБД_Фабрика
{
    public partial class FormAddZakaz : Form
    {
        public FormAddZakaz()
        {
            InitializeComponent();
        }
        public string IdZakazchik = "";  
        string IdTkan = "", IdFur = ""; 

        public struct Tkani
        {
            public string IdTkan, NameTkan, ColorTkan, Width, Length, Description;
            public Image PhotoTkan;
        }

        List<Tkani> LstTkani = new List<Tkani>();
        void GetTkaniFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.dbFabrikaConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Tkan where length > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Tkani Tk = new Tkani();
                Tk.IdTkan = Data["id_tkan"].ToString();
                Tk.NameTkan = Data["Title"].ToString();
                Tk.ColorTkan = Data["id_color"].ToString();
                Tk.Width = Data["Width"].ToString();
                Tk.Length = Data["Length"].ToString();
                Tk.Description = Data["Comment"].ToString();
                try
                {
                    byte[] PhotoByte = (byte[])Data["NamePhoto"];
                    ImageConverter ImConverter = new ImageConverter();
                    Tk.PhotoTkan = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    Tk.PhotoTkan = Properties.Resources.fabric_logo;
                }
                LstTkani.Add(Tk);  
            }
            con.Close();
        }
        void FillLVTkani()
        {
            LVTkani.Items.Clear();
            ImageListTkani.Images.Clear();
            foreach (Tkani Tk in LstTkani)
            {
                ListViewItem LV = new ListViewItem(Tk.NameTkan);
                ImageListTkani.Images.Add(Tk.PhotoTkan);
                LV.ImageIndex = ImageListTkani.Images.Count - 1;
                LVTkani.Items.Add(LV);  
            }
        }
        public struct Furnitura
        {
            public string IdFur, NameFur, CountFur;
            public Image PhotoFur;
        }

        List<Furnitura> LstFurnitura = new List<Furnitura>();
        void GetFurnituraFromDB()
        {
            SqlConnection con = new SqlConnection(Properties.Settings.Default.dbFabrikaConnectionString);
            con.Open();
            SqlCommand Query = new SqlCommand("select * from Furnitura where countfur > 0", con);
            SqlDataReader Data = Query.ExecuteReader();
            while (Data.Read())
            {
                Furnitura Fr = new Furnitura();
                Fr.IdFur = Data["id_fur"].ToString();
                Fr.NameFur = Data["namefur"].ToString();
                Fr.CountFur = Data["countfur"].ToString();
                try
                {
                    byte[] PhotoByte = (byte[])Data["photo"];
                    ImageConverter ImConverter = new ImageConverter();
                    Fr.PhotoFur = (Bitmap)ImConverter.ConvertFrom(PhotoByte);
                }
                catch
                {
                    Fr.PhotoFur = Properties.Resources.fabric_logo;
                }
                LstFurnitura.Add(Fr); 
            }
            con.Close();
        }
        void FillLVFurnitura()
        {
            LVFurnitura.Items.Clear();
            ImageListFur.Images.Clear();
            foreach (Furnitura Fr in LstFurnitura)
            {
                ListViewItem LV = new ListViewItem(Fr.NameFur);
                ImageListFur.Images.Add(Fr.PhotoFur);
                LV.ImageIndex = ImageListFur.Images.Count - 1;
                LVFurnitura.Items.Add(LV); 
            }
        }
        int CutTkan(int WidthTkan, int WidthIzd, int LengthIzd, int CountIzd)
        {
            
            int IzdInRow1 = WidthTkan / WidthIzd;
            int Row1 = CountIzd / IzdInRow1;
            if (IzdInRow1 * Row1 < CountIzd)
                Row1++;
            int CutTkan1 = LengthIzd * Row1;
            int IzdInRow2 = WidthTkan / LengthIzd;
            int Row2 = CountIzd / IzdInRow2;
            if (IzdInRow2 * Row2 < CountIzd)
                Row2++;
            int CutTkan2 = WidthIzd * Row2;
            return Math.Min(CutTkan1, CutTkan2);
        }

        private void FormAddZakaz_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'dbFabrikaDataSet.Tkan' table. You can move, or remove it, as needed.
            this.tkanTableAdapter.Fill(this.dbFabrikaDataSet.Tkan);
            // TODO: This line of code loads data into the 'dbFabrikaDataSet.Izdelie' table. You can move, or remove it, as needed.
            this.izdelieTableAdapter.Fill(this.dbFabrikaDataSet.Izdelie);
            GetTkaniFromDB();
            FillLVTkani();
            GetFurnituraFromDB();
            FillLVFurnitura();
        }

        private void BtnOK_Click(object sender, EventArgs e)
        {
            int NewCountFur = int.Parse(TbxCountFurSklad.Text) -
                int.Parse(TbxCountFur.Text) * int.Parse(TbxCountIzd.Text);
            SqlConnection con = new SqlConnection(Properties.Settings.Default.dbFabrikaConnectionString);
            con.Open();
            string t1 = string.Format(@"update Furnitura
set countfur = {0}
where id_fur = {1}", NewCountFur, IdFur);
            SqlCommand query = new SqlCommand(t1, con);
            // выполнить запрос
            query.ExecuteNonQuery();
            con.Close();

            int WidthTkan = int.Parse(WidthTextBox.Text); 
            int WidthIzd = int.Parse(DgvIzd.CurrentRow.Cells[2].Value.ToString());
            int LengthIzd = int.Parse(DgvIzd.CurrentRow.Cells[1].Value.ToString());
            int CountIzd = int.Parse(TbxCountIzd.Text);
            int NewLengthTkan = int.Parse(LengthTextBox.Text) -
                CutTkan(WidthTkan, WidthIzd, LengthIzd, CountIzd);
            int IdManager = 2;

            try
            {
                con.Open();
                string t = String.Format("insert into Zakaz (id_izd, id_zak, id_men, id_tkan, id_fur, CountFur, CountIzd) " +
                    "values ({0}, {1}, {2}, {3}, {4}, {5}, {6})",
                    LblIdIzd.Text, IdZakazchik, IdManager, IdTkan, IdFur, TbxCountFur.Text, TbxCountIzd.Text);
                SqlCommand query1 = new SqlCommand(t, con);
                query1.ExecuteNonQuery();
                con.Close();
                MessageBox.Show("Заказ сформирован.", "Внимание!",
                    MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close(); 
            }
            catch
            {
                MessageBox.Show("Ошибка добавления нового заказа.", "Внимание!",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

        }

        private void LVFurnitura_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVFurnitura.SelectedItems.Count > 0)  
            {
                int num = LVFurnitura.SelectedIndices[0]; 
                TbxNameFur.Text = LstFurnitura[num].NameFur;
                TbxCountFurSklad.Text = LstFurnitura[num].CountFur;
                IdFur = LstFurnitura[num].IdFur;
            }
            else 
            {
                TbxNameFur.Text = "";
                TbxCountFurSklad.Text = "";
                IdFur = "";
            }
        }

        private void LVTkani_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LVTkani.SelectedItems.Count > 0) 
            {
                int num = LVTkani.SelectedIndices[0];  
                NametkanTextBox.Text = LstTkani[num].NameTkan;
                ColorTextBox.Text = LstTkani[num].ColorTkan;
                WidthTextBox.Text = LstTkani[num].Width;
                LengthTextBox.Text = LstTkani[num].Length;
                DescriptionTextBox.Text = LstTkani[num].Description;
                IdTkan = LstTkani[num].IdTkan;
            }
            else  
            {
                NametkanTextBox.Text = "";
                ColorTextBox.Text = "";
                WidthTextBox.Text = "";
                LengthTextBox.Text = "";
                DescriptionTextBox.Text = "";
                IdTkan = "";
            }
        }
    }
    
}
