﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DLLPass;

namespace СУБД_Фабрика
{
    public partial class FormReg : Form
    {
        public FormReg()
        {
            InitializeComponent();
        }

        private void BtnReg_Click(object sender, EventArgs e)
        {
            if (!ClassCheckPass.CheckPass(PassTextBox.Text))
            {
                MessageBox.Show("Пароль не соответствует требованиям.", "Внимание!", 
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                PassTextBox.Focus();
                return;  // выйти из процедуры
            }

            try
            {
                BsUsers.EndEdit();
                this.usersTableAdapter.Update(this.dbFabrikaDataSet.Users);
            }
            catch
            {
                MessageBox.Show(@"В базе данных уже есть пользователь с таким логином.
Введите уникальный логин пользователя.", "Внимание!", MessageBoxButtons.OK,
MessageBoxIcon.Exclamation);
                LoginTextBox.Focus();
            }

            this.DialogResult = DialogResult.OK;
            Close();
            
        }

        private void FormReg_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'dbFabrikaDataSet.Users' table. You can move, or remove it, as needed.
            this.usersTableAdapter.Fill(this.dbFabrikaDataSet.Users);
            BsUsers.AddNew();
            LblRole.Text = "заказчик";
        }

        private void CbxShowPass_CheckedChanged(object sender, EventArgs e)
        {
            PassTextBox.UseSystemPasswordChar = !PassTextBox.UseSystemPasswordChar;
        }
    }
    
}
